	org $1001-2
	dw $1001
	
	include "!playerv.asm"
OFS = 0	

	db $0b,$10,0,0,$9E,"4109",0,0,0 
	
temp	= $F0	
dest	= $F2
song	= $F4
	;
time		= $0EB8
max_raster	= time + 47
max_raster_chr	= time + 40
track_info	= $0F70

Print16	macro addr
	lda #"$"
	jsr $FFD2
	lda #addr >> 8
	jsr $FB10
	lda #addr & 255
	jsr $FB10
	endm
	
start
	jsr $FF4F
	db $93,$90
	db $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D
	db $0D
	db "PRESS ",$95,"CURSOR RIGHT",$90," TO FAST FORWARD",$0D
	db "      ",$95,"CURSOR DOWN",$90," FOR NEXT SONG",$0D
	db "      ",$95,"SPACE",$90," TO FADE OUT",$0D,$0D
	db "ELAPSED TIME  : 00:00 ( )",$0D
	db "MAXIMUM RASTER: 00    ( )",$0D
	db $90,"MAX. ROOM     : $A000 - $AFFF",$0D
	db $90,"MUSIC         : "
	;
	db 0
	;
	Print16 (music_beg-OFS)
	jsr $FF4F
	db " - ",0
	Print16 (music_end-OFS)
	;
	lda #$00
	sta max_raster
	;
	lda #$41
	sta $FF19
	lda #$51
	sta $FF15
	;
	; ---
	;
	ldy #$00
	ldx #$00
delay	inx
	bne delay
	iny
	bne delay
	;
	sei
	sta $FF3F
	;
	; ----------
	;
;	lda #$50
;	sta dest+1
;	ldy #$00
;	sty dest
;cl2	tya
;cl1	sta (dest),y
;	iny
;	bne cl1
;	;    
;	inc dest+1
;	lda dest+1
;	cmp #$FD
;	bne cl2
	;
rs	ldx #$FF
	stx song
	;
ns	inc song
	ldx song
	cpx #$07
	bcs rs
	jsr PLAYER_FREQ_INIT - OFS
	;
	jsr RESET_TIMER
	;
	; ----------
	;
sync0	lda #$BF
	sta $FD30
	sta $FF08
	lda $FF08
	and #$08
	bne sync0a
	;
	inc $FF19
	jsr PLAYER - OFS
	jsr PLAYER_SOUND - OFS
	jsr INC_TIMER
	dec $FF19
	;
sync0a	lda $FF1D
	cmp #$40
	bne sync0
	;
	dec $FF19
	lda $FF1D
	sta r_start+1
	;
	jsr PLAYER - OFS
	;
vol_down
	lda #$00
	beq no_vol_down
	;
vol_delay
	lda #$00
	clc
	adc #$01
	and #$0F
	sta vol_delay+1
	bne no_vol_down
	;
	lda VOLUME
	clc
	adc #$09
	cmp #21*9
	bne do_vol_down
	jmp $FFF6
do_vol_down
	sta VOLUME
no_vol_down
	;
	inc $FF19
	;
	lda $FF1D
	sec
r_start	sbc #$00
	cmp max_raster
	bcc not_larger
	;
	sta max_raster
	;
	and #$0F
	tax
	lda hex_char,x
	sta max_raster_chr+1
	;
	lda max_raster
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	sta max_raster_chr
	;
not_larger
	;
	jsr INC_TIMER
	;
	jsr dump_track_info
	;
	;LDA $FF12
	;AND #$03
	;JSR $FB10
	;LDA $FF0E
	;JSR $FB10
	;LDA #$0D
	;JSR $FFD2
	;
kdelay	ldy #$00
	beq kcheck
	dey
	sty kdelay+1 
	jmp x6
	;
kcheck	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10
	bne x5
	;
	lda #$21
	sta $FF15
	sta vol_down+1	; fade out on space
	;
	ldy #$10
	sty kdelay+1 
	jmp x6
	;
x5	lda #$DF
	sta $FD30
	sta $FF08
	lda $FF08
	and #$01
	bne x6
	;
	ldy #$10
	sty kdelay+1 
	jmp ns		; reset song
x6
	;
	; ---
	;
sync3	lda $FF1D
	cmp #$E0
	bne sync3 
	;
	dec $FF19
	jsr PLAYER_SOUND
	inc $FF19
	;
	jmp sync0
	;
	
RESET_TIMER
	lda #$00
	sta time+7
	lda #$30
	sta time+0
	sta time+1
	sta time+3
	sta time+4
	rts
	
INC_TIMER
	lda time+7
	clc
	adc #$01
	cmp #50
	bne inc1
	;
	ldx #$05
inc2	dex 
	cpx #$02
	beq inc2
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #$30
inc3	sta time,x
	cmp #$30
	beq inc2
	;
	lda #$00
inc1	sta time+7
	;
	rts
time_end
	db $3A,$3A,$3A,$36,$3A
hex_char
	db "0123456789",1,2,3,4,5,6
	
dump_track_info
	lda #track_info & 255
	sta dest
	lda #track_info >> 8
	sta dest+1
	;
	ldx #$00
dt2	stx x_save+1
	lda CH1_LO,x
	sta temp
	lda CH1_HI,x
	sta temp+1
	;
	ldx temp
	jsr write_word
	jsr add_dest_1
	;
	ldy #$00
dt1	lda (temp),y
	jsr write_byte
	jsr add_dest_1
	iny
	cpy #$08
	bne dt1
	;
	lda #$0B
	jsr add_dest
	;
x_save	ldx #$00
	inx
	cpx #$03		; stop at channel #
	bne dt2
	;
	; ---
	;
	lda #track_info & 255
	sta dest
	lda #track_info >> 8
	sta dest+1
	;
	lda dest
	clc
	adc #$20
	sta dest
	;
	lda F1HI
	and #$03
	jsr write_byte
	lda F1LO
	jsr write_byte
	;
	lda dest
	clc
	adc #$24
	sta dest
	;
	lda F2HI
	and #$03
	jsr write_byte
	lda F2LO
	jsr write_byte
	;
	;
	rts
	
write_word
	stx x_sav2+1
	jsr write_byte
x_sav2	lda #$00
	;
write_byte
	sty y_save+1
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	ldy #$00
	sta (dest),y
	pla
	and #$0F
	tax
	lda hex_char,x
	iny
	sta (dest),y
	;
	lda #$02
	jsr add_dest
y_save	ldy #$00
	rts

add_dest_1
	lda #$01
add_dest
	clc
	adc dest
	sta dest
	bcc *+4
	inc dest+1
	rts
	
	org $A000
music_beg
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"
music_end
	
;[eof]